#property copyright "Copyright  2006, COT4MetaTrader"
#property link      "www.cot4metatrader.com"

#property indicator_separate_window
#property indicator_color1 Black
#property indicator_color2 Red
#property indicator_color3 Lime
#property indicator_color4 Aqua
#property indicator_buffers 4

//---- indicator parameters

extern  bool    ShowCommercials = true;
extern  bool    ShowSpecs       = true;
extern  bool    ShowSmalls      = true;
extern  bool    ShowOpenInt     = true;
extern  bool    ShowUSD         = false;

extern string  Filename        =  "COT.csv";

int      aIndex         = 0;
int      aCurrency      = 1;
int      aDate          = 2;
int      aDuration      = 3;
int      aComm          = 4;
int      aSpec          = 5;
int      aSmall         = 6;
int      aOpenInt       = 7;
#define  aDimension       8

int      NewsItems,FileItems,FutureItems;
string   Currency;
double   NewsIndicator[];
double   Comm[],Spec[],Small[],OpenInt[];
datetime TimeOfLastBar;
string   FileArray[1000][aDimension];
int      SecondsInPeriod;
string   COTArray[][aDimension];

//+------------------------------------------------------------------+
//| LoadCSVFile                                                      |
//+------------------------------------------------------------------+
int LoadCSVFile(string Filename, string& ThisArray[][], int ThisArrayColumns)
{
  int i, j, k;
  string ThisElement;                                      // string for reading
  int    ArrayDim=ArraySize(ThisArray)/ThisArrayColumns; // initial array size
  int    ThisRow = 0 ,ThisColumn = 0;                              // realy read lines count
   
  int handle=FileOpen(Filename, FILE_CSV|FILE_READ,',');

  if(handle < 1) 
  { 
    FileError(Filename); 
    return(false);
  }

  //---- read file to text array
  ThisRow = 0;
  ThisColumn = 0;
  while(FileIsEnding(handle) == false)
  {
    if(ThisRow == ArrayDim)
    {
      if (ArrayDim <= 10)
        int add = 1;
      else
        if (ArrayDim <= 100)
          add = 10;
        else       
          if (ArrayDim <= 1000)
            add = 100;
          else
            add = 1000;
 
      ArrayResize(ThisArray,ArraySize(ThisArray)/ThisArrayColumns+add);
      ArrayDim += add;
    }
    
    ThisElement = FileReadString(handle);
 
    ThisArray[ThisRow][ThisColumn] = ThisElement;
      
    ThisColumn ++;
    if (ThisColumn == ThisArrayColumns)
    {
      ThisColumn = 0;
      ThisRow ++;
    }
  }

  FileClose(handle);
  return(ThisRow);
}

//+------------------------------------------------------------------+
//| Function..: FileError                                            |
//+------------------------------------------------------------------+
void FileError(string Filename2)
{
  Alert("File:", Filename2, " Error:", GetLastError());
  return;
}
//+------------------------------------------------------------------+
//| initialization function                                          |
//+------------------------------------------------------------------+
int init()
{
 
  if ((StringSubstr(Symbol(),0,6) != "GBPUSD" && 
       StringSubstr(Symbol(),0,6) != "EURUSD" && 
       StringSubstr(Symbol(),0,6) != "AUDUSD" && 
       StringSubstr(Symbol(),0,6) != "USDCHF" && 
       StringSubstr(Symbol(),0,6) != "USDJPY" && 
       StringSubstr(Symbol(),0,6) != "USDCAD" && 
       StringSubstr(Symbol(),0,6) != "USDMXN" && ShowUSD == false) ||
      (StringSubstr(Symbol(),0,3) != "USD" && 
       StringSubstr(Symbol(),3,3) != "USD" && ShowUSD == true) || 
       Period() > PERIOD_W1)
  {
  
    Print("Commitments of Traders Version 2 is intended only for GBPUSD, EURUSD, AUDUSD, USDCHF, USDJPY, USDCAD or USDMXN pairs");
    return(-1);
  }
  else
  {
    if (ShowUSD)
    {
      Currency = "USD";
    }
    else
    {
      if (StringSubstr(Symbol(),3,3) == "USD") 
        Currency = StringSubstr(Symbol(),0,3);
      else
        Currency = StringSubstr(Symbol(),3,3);
    }
      
    //---- drawing settings
    if (ShowOpenInt)
      SetIndexStyle(0,DRAW_LINE,EMPTY,EMPTY,Black);
    else
      SetIndexStyle(0,DRAW_NONE,EMPTY,EMPTY,Black);
    if (ShowCommercials)
      SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,Red);
    else
      SetIndexStyle(1,DRAW_NONE,EMPTY,EMPTY,Red);
    if (ShowSpecs)
      SetIndexStyle(2,DRAW_LINE,EMPTY,EMPTY,Green);
    else
      SetIndexStyle(2,DRAW_NONE,EMPTY,EMPTY,Green);
    if (ShowSmalls)
      SetIndexStyle(3,DRAW_LINE,EMPTY,EMPTY,Blue);
    else
      SetIndexStyle(3,DRAW_NONE,EMPTY,EMPTY,Blue);
    
    IndicatorDigits(0);
    IndicatorShortName(StringConcatenate(Currency," Commitment Of Traders"));
    //---- indicator buffers mapping
    SetIndexBuffer(0,OpenInt);
    SetIndexBuffer(1,Comm);
    SetIndexBuffer(2,Spec);
    SetIndexBuffer(3,Small);
    
    SetIndexEmptyValue(0,0.0);
    SetIndexEmptyValue(1,0.0);
    SetIndexEmptyValue(2,0.0);
    SetIndexEmptyValue(3,0.0);
    
    SetIndexLabel(0,"Open Interest");
    SetIndexLabel(1,"Commercial");
    SetIndexLabel(2,"Non-Commercial");
    SetIndexLabel(3,"Non-Reportable");

    Print("Commitments of Traders Version 2 , Copyright (C) 2006, www.COT4MetaTrader.com");
    Print("Commitments of Traders-02 comes with ABSOLUTELY NO WARRANTY");
    Print("This is free software, and you are welcome to redistribute it");
    Print("under certain conditions; For details see license.txt.");

    switch (Period())
    {
      case PERIOD_M1:
        SecondsInPeriod = 60; 
        break;     
      case PERIOD_M5: 
        SecondsInPeriod = 5*60; 
        break;     
      case PERIOD_M15: 
        SecondsInPeriod = 15*60; 
        break;     
      case PERIOD_M30: 
        SecondsInPeriod = 30*60; 
        break;     
      case PERIOD_H1: 
        SecondsInPeriod = 60*60; 
        break;     
      case PERIOD_H4: 
        SecondsInPeriod = 4*60*60;  
        break;     
      case PERIOD_D1: 
        SecondsInPeriod = 24*60*60;  
        break;     
      case PERIOD_W1: 
        SecondsInPeriod = 24*60*60*7;  
        break;     
    }      

    // go read the file - note this is done once only in init
    FileItems = LoadCSVFile(Filename,FileArray,aDimension);
    // size the array
    // do a very basic quality check what was read
    int IndexCheck = 1;
    for (int i = 1; i < FileItems; i++)
    {
      if (StrToInteger(FileArray[i][aIndex]) != IndexCheck)    
      {

        Alert("Error reading file on line "+i+". Index contains "+FileArray[i][aIndex]);
        break;
      }
      else  
        IndexCheck++;
    }

    TimeOfLastBar = 0;
    return(0);
  }
}

//+------------------------------------------------------------------+
//| ShowCOT
//+------------------------------------------------------------------+
int ShowCOT()
{
  datetime Earliest = Time[Bars-1] - 60*60*24*7;
  for (int i = FileItems; i >= 1; i--)
  {
    if (FileArray[i][aCurrency] == Currency &&
         StrToTime(FileArray[i][aDate]+" 00:00") >= Earliest)
    {
      datetime StartTime = StrToTime(FileArray[i][aDate]+" 00:00");
      int StartBar = iBarShift(NULL,0,StartTime,true);
      while (StartBar == -1 && StartTime <= Time[0])
      {
        StartTime = StartTime + SecondsInPeriod;
        StartBar = iBarShift(NULL,0,StartTime,true);
      }
      
      if (StartBar != -1)
      {
        for (int j=StartBar; j>=0; j--)
        {
          if (Time[j] < StrToTime(FileArray[i][aDate]+" 00:00") + 60*60*24*StrToDouble(FileArray[i][aDuration]))
          {
            Comm[j] = MathMax(0.0001,StrToDouble(FileArray[i][aComm]));
            Spec[j] = MathMax(0.0001,StrToDouble(FileArray[i][aSpec]));
            Small[j] = MathMax(0.0001,StrToDouble(FileArray[i][aSmall]));
            OpenInt[j] = MathMax(0.0001,StrToDouble(FileArray[i][aOpenInt]));
          }
          else  
          {
            j = 0;
          }
        }
      }
    } 
  }
  return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
  return(0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
  int limit;
  int counted_bars=IndicatorCounted();


  if ((StringSubstr(Symbol(),0,6) != "GBPUSD" && 
       StringSubstr(Symbol(),0,6) != "EURUSD" && 
       StringSubstr(Symbol(),0,6) != "AUDUSD" && 
       StringSubstr(Symbol(),0,6) != "USDCHF" && 
       StringSubstr(Symbol(),0,6) != "USDJPY" && 
       StringSubstr(Symbol(),0,6) != "USDCAD" && 
       StringSubstr(Symbol(),0,6) != "USDMXN" && ShowUSD == false) ||
      (StringSubstr(Symbol(),0,3) != "USD" && 
       StringSubstr(Symbol(),3,3) != "USD" && ShowUSD == true) || 
       Period() > PERIOD_W1)
  {
    return(-1);
  }
  else
  { 
    if(counted_bars<0) 
      return(-1);

    if(counted_bars>0) 
      counted_bars--;
    
    limit=Bars-counted_bars;

    if (limit > 2 || TimeOfLastBar != Time[0])
    {
      TimeOfLastBar = Time[0];
      ShowCOT();
    }
  }
  return(0);
}